Redmine - Feature #13919

Mention user on issues and wiki pages using @user with autocomplete

2013-05-01 02:57 - Diego Antunes

Status: Closed Start date:

Priority: Normal Due date:

Assignee: Marius BALTEANU % Done: 0%
Category: Email notifications Estimated time: 0.00 hour
Target version: 5.0.0

Resolution: Fixed

Description

https://github.com/dwarburt/redmine-mention-plugin is ok, but I think would be awesome to have something like Github where it has

an inline autocomplete for users etc. | think this should be built into the core plugins maybe?

for reference check this out https://github.com/tactivos/jquery-sew

Related issues:

Related to Redmine - Feature #4179: Link to user in wiki syntax

Related to Redmine - Feature #26127: Display user logins on profiles

Related to Redmine - Feature #31989: Inline issue auto complete (#) in fields...
Related to Redmine - Feature #36162: Add notification reason to the email ins...
Related to Redmine - Feature #36699: Change the text of the user link when co...
Related to Redmine - Defect #36909: Mentions not working if status is changed
Related to Redmine - Defect #37369: Mention auto-complete not works in bulk-e...
Related to Redmine - Patch #37938: Unused permission "Mention user"

Related to Redmine - Feature #39529: Add tooltips for clarifying non-natifiab...
Related to Redmine - Feature #39528: Change mention link color for users with...
Has duplicate Redmine - Feature #15828: mention system.

Has duplicate Redmine - Feature #16478: Several people involved / Mention som...
Has duplicate Redmine - Feature #29471: Allow for calling users by their user...
Has duplicate Redmine - Feature #38542: Better username completion in the editor

Closed 2009-11-08
Closed

Closed

New

Closed

Closed

Closed

Closed

Needs feedback
New

Closed

Closed

Closed

Closed

Associated revisions

Revision 21435 - 2022-02-23 22:16 - Marius BALTEANU
Allow users to be mentioned using @ in issues and wiki pages (#13919):
e the user must have add watchers permission on that object in order to mention other users

e mentioned user will receive a notification email
¢ only visible users who can view the object can be mentioned

Revision 21440 - 2022-02-24 22:54 - Marius BALTEANU

Add class user-mention to user classes when user is linked using @ (#36699, #13919).

Revision 21468 - 2022-03-19 11:00 - Marius BALTEANU
Render mentioned users with leading @ and highlight (#36699, #13919).

History

#1 - 2013-05-03 16:28 - Jelle Bekker

I've tried to implement this at https:/github.com/Jbekker/redmine_mention_plugin/tree/autocomplete

| changed the syntax to :user instead of user user because that doesn't get triggered when typing a email-address :-( I'm sure there is a way to filter a

email adress out but im not a Ruby/JavaScript pro yet.

Currently im not checking if jquery is loaded and there are a few other things that could be done better | suppose. Patches and pull requests are

welcome!

#2 - 2014-04-02 07:50 - Arkhitech - More, Better, Faster!

+1 for this feature. Mentioned user should not get added to the watcher's list though. Only a one time email should be triggered saying that 'You were
mentioned...." or something. Also, there should be email notification setting, where you can appropriately adjust that you want to receive mention
email notifications only, etc.

#3 - 2014-04-30 11:38 - Toshi MARUYAMA

- Related to Feature #16478: Several people involved / Mention someone added

#4 - 2014-05-24 10:50 - Andriy Lesyuk

FYI, mentions with email notifications are implemented in WikiNG 1.0.0b.

#5 - 2014-06-22 05:19 - Toshi MARUYAMA
- Has duplicate Feature #15828: mention system. added

#6 - 2014-06-22 05:21 - Toshi MARUYAMA

- Related to deleted (Feature #16478: Several people involved / Mention someone)

#7 - 2014-06-22 05:22 - Toshi MARUYAMA

- Has duplicate Feature #16478: Several people involved / Mention someone added

#8 - 2014-07-09 07:47 - Dmitry Beloglazov

+1 for this one. Would be really nice to have.

#9 - 2014-08-27 16:46 - Alex Sherman

+1
| also tried this one: http://www.redmine.org/plugins/redmine-mentions

#10 - 2015-07-26 08:39 - Lai Wei-Hwa

The plugin that Alex Sherman posted is cool but doesn't work on comments. +1 to get this implemented.
#11 - 2016-01-14 20:45 - Kamil Franckiewicz
Arkhitech - More, Better, Faster! wrote:
+1 for this feature. Mentioned user should not get added to the watcher's list though. Only a one time email should be triggered saying that 'You

were mentioned...." or something. Also, there should be email notification setting, where you can appropriately adjust that you want to receive
mention email notifications only, etc.

| agree. +1

#12 - 2016-01-15 13:19 - budo kaiman

+1 to single email. Plugins for this feature have always been unreliable and trying to communicate on redmine without setting people as watchers is
awkward and inefficient.

#13 - 2016-01-28 12:10 - Konstantin Ladutenko
Lai Wei-Hwa wrote:

The plugin that Alex Sherman posted is cool but doesn't work on comments. +1 to get this implemented.

Alex Sherman wrote:

+1
| also tried this one: http://www.redmine.org/plugins/redmine-mentions

| used the same plugin by Arkhitech, it looks to work as expected for comments, however, does not notify user when mentioned in description of the
task. To make autocomplete feature to work with redmine 2.5.2 | used a patch (see pull requtest on GitHub
https://github.com/arkhitech/redmine_mentions/pull/34 )

#14 - 2016-04-25 16:22 - Steve Légaré

Arkhitech - More, Better, Faster! wrote:

+1 for this feature. Mentioned user should not get added to the watcher's list though. Only a one time email should be triggered saying that 'You
were mentioned...." or something. Also, there should be email notification setting, where you can appropriately adjust that you want to receive
mention email notifications only, etc.

| agree! +1

#15 - 2016-08-01 08:55 - Anh Le Giang

+1

#16 - 2016-10-19 09:31 - sch uess

+1

#17 - 2016-11-03 23:44 - Frank Paaske

Yes, please add this feature!

#18 - 2016-11-17 20:12-Y Z

+1

#19 - 2017-01-23 11:23 - Roman Kovtyukh

+1

#20 - 2017-07-31 05:49 - Toshi MARUYAMA

- Related to Feature #26127: Display user logins on profiles added

#21 - 2017-08-21 05:53 - Yasukazu Nagatomi

| agree! +1

#22 - 2017-09-12 05:44 - Joe Price

+1 Keep the dream alive!

#23 - 2017-09-22 18:39 - Alexandre Audige

+1

#24 - 2018-02-09 08:42-CF

+1

#25 - 2018-04-04 08:22 - Kevin Palm

+1

#26 - 2018-06-06 12:38 - Aleksei Trubnikov

+1

#27 - 2018-06-25 16:33 - sebastien lemaitre

+1

#28 - 2018-08-23 14:49 - Maickel Neitzke

+1

#29 - 2018-09-01 01:56 - Kamil .

+1

#30 - 2018-09-01 05:27 - Go MAEDA

- Has duplicate Feature #29471: Allow for calling users by their username added

#31 - 2018-12-19 06:58 - Anonymous

+1

#32 - 2019-01-14 21:50 - Tantic o
+1

#33 - 2019-02-05 16:40 - Muhammad Yusuf

+1

#34 - 2019-03-07 05:41 - Mizuki ISHIKAWA
- File feature_13919_v1.patch added

The attached patch adds a feature to mention to the user.

e Use user link such as "user:jsmith" "@jsmith" "user#2".
* Notify when the user mentioned by the user link has the authority to view the element and has not rejected the notification.

The test has not been written yet for this patch.
There is room for improvement in this patch.
I'm looking forward to getting your feedback.

#35 - 2019-03-12 14:22 - Yuuki NARA

+1

#36 - 2019-03-24 03:44 - Go MAEDA
- Category changed from Core Plugins to Email notifications

- Target version set to Candidate for next major release

#37 - 2019-03-26 07:16 - Mizuki ISHIKAWA
- File feature_13919_v2.patch added

| attached a patch to which test code was added.

#38 - 2019-04-07 09:49 - Go MAEDA

- Target version changed from Candidate for next major release to 4.1.0
Setting the target version to 4.1.0.

#39 - 2019-04-25 08:25 - Marius BALTEANU
- Assignee set to Marius BALTEANU

| would like to test the solution proposed because looking over the patch proposed, | think that it cannot be committed as it is and it'll require more
work.

#40 - 2019-05-14 14:03 - Aleksandar Pavic

+1

Mention should actually trigger email notification (add user as watcher if it's not added)

#41 - 2019-05-16 02:40 - John Ramsden

We've been looking at this feature, and we're hoping to move from to it from the redmine_mention_plugin plugin®. The issue we're having with the
current plugin is that it doesn't support our usernames that are emails. Are there any plans to support that in this feature? Or if we plan to use this
feature should we move away from emails as usernames?

In the existing plugin when we write @, an autocomplete box opens, when we choose a user that is not an email, it converts it to a link to the user
correctly, whereas when using an email it does not. We tried modifying the regex but | guess there's more to it than that.

' https://github.com/stpl/redmine_mention_plugin

#42 - 2019-05-25 05:45 - Go MAEDA
Marius BALTEANU wrote:
| would like to test the solution proposed because looking over the patch proposed, | think that it cannot be committed as it is and it'll require

more work.

Could you point out what needs to be corrected? Maybe Mizuki can work on correcting the patch.
#43 - 2019-06-16 14:07 - Marius BALTEANU
Thanks Mizuki for writing the patch.

My main concern regarding the proposed solution is that there is no way for the user to control the notification emails, he'll be notified every time
when someone will mention him.

| see 2 options:

1. We add a new event type ("On mention") and some options for the user to control when he should be notified or not. But this solution it's quite
complex and it'll require more time to work on it. Also, the message from the notification emails should contain something like "You received this email
because someone mentioned you".

2. We just add the user as watcher and the notifications will be controlled by the actual notification rules. In addition, we can add in the user
preferences an option regarding if he wants to auto watch the objects where he is mentioned.

My proposal is to go with 2 for now and see in the future how can develop more this feature.
Anyway, another main improvement here is to have a client side feature to allow users to mention someone using an autocomplete dropdown.
Any other feedback on this is welcome.

#44 - 2019-06-16 22:11 - Anders Thomsen
Marius BALTEANU wrote:

My main concern regarding the proposed solution is that there is no way for the user to control the notification emails, he'll be notified every time
when someone will mention him.

| see 2 options:

2. We just add the user as watcher and the notifications will be controlled by the actual notification rules. In addition, we can add in the user
preferences an option regarding if he wants to auto watch the objects where he is mentioned.

Won't adding mentioned users as watchers cause them to get even more e-mails? Consider a scenario where developers (watching the issue)
frequently adds notes to an issue. Once in a while they need to notify some stakeholder (not watching as this would cause too many irrelevant
notifications) which they do by mentioning them.

Or perhaps | misunderstand - by "add the user as watcher" do you mean only for that one request (not persisting the setting)?

#45 - 2019-06-17 14:38 - Marius BALTEANU

Anders Thomsen wrote:
Won't adding mentioned users as watchers cause them to get even more e-mails? Consider a scenario where developers (watching the issue)
frequently adds notes to an issue. Once in a while they need to notify some stakeholder (not watching as this would cause too many irrelevant
notifications) which they do by mentioning them.
Or perhaps | misunderstand - by "add the user as watcher" do you mean only for that one request (not persisting the setting)?

You're right, it'll generate more emails.

How do you see the implementation?

#46 - 2019-06-18 20:23 - Anders Thomsen

In a company there should be no problem as mentioning a user would have the same effect as sending an email to the user. So | believe the main
concern would be in public websites like this one.

It could be controlled by a new permission: "Notify mentioned users". If one don't have that permission, no drop-down should be displayed typing in @
and of cause no notification e-mail should be sent.

#47 - 2019-06-20 07:24 - Go MAEDA
Marius BALTEANU wrote:

My main concern regarding the proposed solution is that there is no way for the user to control the notification emails, he'll be notified every time
when someone will mention him.

| think it is the ideal behavior because this feature is to forcefully send a notification to another user. Since the notification is sent only when a user
used "@login" or other special markup, | think it is not a big problem.

#48 - 2019-06-20 09:53 - Jean-Philippe Lang

- Target version changed from 4.1.0 to 4.2.0
#49 - 2019-07-22 07:59 - Mizuki ISHIKAWA
| agree with #139194#note-47.

http://www.redmine.org/projects/redmine/repository/entry/trunk/app/models/user.rb#L 790
always send to project members except when mail_notification is set to 'none'

If mail_notification is not none, a notification will be sent when the news is created(#4700).
| think that notifications when mentioned are as important as news notifications.

#50 - 2019-09-01 05:22 - Go MAEDA

- Related to Feature #31989: Inline issue auto complete (#) in fields with text-formatting enabled added

#51 - 2019-09-10 19:07 - Marius BALTEANU

- File 0001-Demo-for-acts_as_mentionable.patch added

00 0 ISHIKAWA, what do you think if we try to implement this feature using a new plugin named "acts_as_mentionable" which will be able to look for
mentioned users (for now, it can be extended to another entities in the future) only on the changed values and only on configured attributes per entity
(for example: Issue#description, Journal#notes, CustomFieldValue#value, etc)?

I'm attaching a patch for demo purposes which:
- gives you access to all attributes that are changed during an update using saved_changes
- gives you access to the attributes where we should look after mentions through mentionable_attributes
Further more, | think we should have a mechanism that calculates the users that should be notified by making a diff between the users that were been
notified based on the old value and the users that should be notified based on the new value. In this way, we avoid sending another mention if
someone just append a short text to an existing description which already contains a mention. Also, the email send to the user should be a new mail
template, something like "You have been mentioned in #{issue} by #{user}".
Please let me know what do you think about this. Any other ideas are welcome!
#52 - 2019-09-11 02:24 - Mizuki ISHIKAWA
Marius BALTEANU wrote:
Please let me know what do you think about this.
Thank you for your activity on this Issue(feature)!

The implementation using the "acts_as_mentionable" plugin looks more beautiful than the patch implementation | attached in #13919#note-34.

Also, the email send to the user should be a new mail template, something like "You have been mentioned in #{issue} by #{user}".

That looks good.

If the mention user is always notified of changes to mentionable attribute(eg issue),
| think it would be ideal to send only the email "You have been mentioned in #{issue} by #{user}". (Do not send existing email "Issue#1 has been
updated by #{user}")

#53 - 2019-09-11 22:19 - Marius BALTEANU
Mizuki ISHIKAWA wrote:
Thank you for your activity on this Issue(feature)!

The implementation using the "acts_as_mentionable" plugin looks more beautiful than the patch implementation | attached in #13919#note-34.

Thanks for you quick feedback. Do you like to continue from here? | would be very happy to review the patch.

#54 - 2020-02-13 02:37 - Mizuki ISHIKAWA
- File draft-feature-13919-v3.patch added

- File draft-acts_as _mentionable.patch added

| am developing a patch based on 0001-Demo-for-acts_as_mentionable.patch, but | thought that there are some problems by sharing the process
with acts_as_mentionable.

Existing notification emails have been optimized to deliver more information per event, such as mailer/issue_add.html.erb, mailer/issue_edit.html.erb
and mailer/news_added.html.erb .
For example, issue_edit includes Issue information as well as Journal information as shown below.

Issue #1 has been updated by Redmine Admin.
I Description updated (diff)
Change description.

Bug #25: Subject

Author: Redmine Admin

Status: New

Priority: Normal

Start date: 2020-02-04
Searchable field: Default string
John Smith Dave Lopper
Description

Description comment.

| find it difficult to replace these optimized emails with a common email template created based on 0001-Demo-for-acts_as_mentionable.patch.

Therefore, | am planning to develop a patch that replaces the subject or the first sentence(example: Issue #25 has been updated by Redmine Admin)
of the existing notification email with "You have been mentioned in Issue #25 by Redmine Admin" based on the feature_13919_v2.patch.

| have created a draft patch that works with two designs.

e Patch with common processing based on 0001-Demo-for-acts_as_mentionable.patch: draft-acts_as_mentionable.patch
e Patch that adds a function to change the email subject to the feature_13919_v2.patch: draft-feature-13919-v3.patch

| welcome feedback on code design, etc.

#55 - 2020-03-04 10:49 - De Lo

In Gitlab, when you mention someone, they gets automatically subscribed to the thread and receives all further updates on the issue. We use that
behaviour in our company and it very well suits our needs.

Having a different paradigm in another tool is misleading. IMHO, the fact that mentioned user could be added to watcher list should be controlled via a
flag in the settings. As | can see on this plugin: https:/github.com/arkhitech/redmine_mentions, its a feature which has been multiple times been
requested.

What's your opinion ?

#56 - 2020-04-02 22:23 - Marius BALTEANU

- File 0001-wip-for-acts_as_mentionable.patch added

Mizuki ISHIKAWA wrote:

| am developing a patch based on 0001-Demo-for-acts_as_mentionable.patch, but | thought that there are some problems by sharing the
process with acts_as_mentionable.

Existing notification emails have been optimized to deliver more information per event, such as mailer/issue_add.html.erb
mailer/issue_edit.html.erb and mailer/news_added.html.erb .
For example, issue_edit includes Issue information as well as Journal information as shown below.

(-]

| find it difficult to replace these optimized emails with a common email template created based on 0001-Demo-for-acts_as_mentionable.patch.

Therefore, | am planning to develop a patch that replaces the subject or the first sentence(example: Issue #25 has been updated by Redmine
Admin) of the existing notification email with "You have been mentioned in Issue #25 by Redmine Admin" based on the feature_13919_v2.patch.

| have created a draft patch that works with two designs.

e Patch with common processing based on 0001-Demo-for-acts_as_mentionable.patch: draft-acts_as_mentionable.patch
e Patch that adds a function to change the email subject to the feature_13919_v2.patch: draft-feature-13919-v3.patch

| welcome feedback on code design, etc.
Thanks Mizuki for the work made on top of my patch. | took a look over your patches and I'm not sure why all those changes made to
ApplicationHelper#parse_redmine_links and User are needed, most probably | missed something.
| made a new version of my patch (still WIP) which includes the auto complete feature for users and a working version of acts_as_mentionable. For

now, notified_mentions receive the same existing email from Redmine, but we can easily made some changes to the email template in order to
include a message like "You have been mentioned" or something similar. I'm attaching the patch for testing purposes.
#57 - 2020-04-05 21:03 - Marius BALTEANU

- File deleted (0001-wip-for-acts_as_mentionable.patch)

#58 - 2020-04-05 21:17 - Marius BALTEANU
- File email_template.png added

- File 0001-Demo-for-acts_as_mentionable.patch added

I've updated the patch in order to:

1.ignore the users mentioned in quoted text or pre tags.
2. add in the email template the sentence "You have been mentioned in it." (for now only when adding/editing issue)

email_template.png
This patch is good enough to demonstrate how the feature will work from a user perspective. Please let me know what do you think. If we decide that
it's good enough, | will finish the work needed (tests, update all email templates, etc) in order to finally include this feature in Redmine core.

#59 - 2020-04-16 04:47 - Mizuki ISHIKAWA
- File 0002-Prevent-multiple-emails-from-being-sent-to-a-user.patch added

- File 0003-Add-permission-check-before-sending-email.patch added

Marius BALTEANU wrote:

Thanks Mizuki for the work made on top of my patch. | took a look over your patches and I'm not sure why all those changes made to
ApplicationHelper#parse_redmine_links and User are needed, most probably | missed something.

e Changes to User is to check if the mentioned user has permission to access that object. Do not send notification emails to users who do not
have access to the mentioned object.

¢ Changes to ApplicationHelper#parse_redmine_links is to change the color of the link only to the user who is sent the permission check result
email. (This is not absolutely necessary)

Marius BALTEANU wrote:

| made a new version of my patch (still WIP) which includes the auto complete feature for users and a working version of acts_as_mentionable.
For now, notified_mentions receive the same existing email from Redmine, but we can easily made some changes to the email template in order
to include a message like "You have been mentioned" or something similar. I'm attaching the patch for testing purposes.

Thanks for developing the patch, | think 0001-Demo-for-acts_as_mentionable.patch is a much better design than the draft-acts_as_mentionable.patch
| wrote.

| attached some patches to solve it because | had some concerns.

* 0002-Prevent-multiple-emails-from-being-sent-to-a-user.patch

Fix an issue where one user receives two notification emails when mentioning a user who originally planned to be notified(Issue#notified_users).

e 0003-Add-permission-check-before-sending-email.patch

@dummy_user who is not a member of the C project cannot see issues in the C project. Even if @dummy_user is mentioned in the C project issue, |
don't think the notification email should reach @dummy_user.

This patch adds a process to decide whether to send a notification email according to the permissions of the mentioned user.
#60 - 2020-04-16 04:48 - Mizuki ISHIKAWA
De Lo wrote:

In Gitlab, when you mention someone, they gets automatically subscribed to the thread and receives all further updates on the issue. We use
that behaviour in our company and it very well suits our needs.

Having a different paradigm in another tool is misleading. IMHO, the fact that mentioned user could be added to watcher list should be controlled
via a flag in the settings. As | can see on this plugin: https:/github.com/arkhitech/redmine_mentions, its a feature which has been multiple times
been requested.

What's your opinion ?

| think the above feature to add mentioned users to watchers should be considered as an additional implementation after this feature (#13919) is

2025-07-03 8/12


https://www.redmine.org/attachments/25155
https://www.redmine.org/attachments/24815
https://www.redmine.org/attachments/25199
https://www.redmine.org/attachments/25200
https://github.com/arkhitech/redmine_mentions
https://www.redmine.org/issues/13919

committed.
Example, Add the mentioned user to watcher if Setting.add_mentioned_users_to_watchers is true.

#61 - 2021-03-17 22:37 - Marius BALTEANU
- Target version changed from 4.2.0 to 5.0.0

Unfortunately, I'm not able to finish this for 4.2.0.
#62 - 2021-09-09 14:58 - Fabiano Souza
Hi,
On track for 5.0.0 ?
#63 - 2021-11-06 09:15 - Diego Antunes
Fabiano Souza wrote:

Hi,

On track for 5.0.0 ?

What the hell, | check this email every now and then "about once a year, lol". | added this 8 years ago, 8 YEARS!!! glad | stopped using Redmine
about 7 years ago.

#64 - 2021-11-08 13:53 - Dmitry Babenko
Diego Antunes wrote:
What the hell, | check this email every now and then "about once a year, lol". | added this 8 years ago, 8 YEARS!!! glad | stopped using Redmine

about 7 years ago.

Diego, it's free and open-source software. And since we are not paying for its development or usage we can't really claim for anything.
We can support and encourage the developers and maintainers, but definitely not blame them. Especially, when a requested issue is not a bug, but a
new feature.

PS: I'm also looking forward to this feature. And it's probably the last feature | really miss in Redmine :)

#65 - 2021-11-08 23:15 - Marius BALTEANU

Dmitry Babenko wrote:
Diego, it's free and open-source software. And since we are not paying for its development or usage we can't really claim for anything.
We can support and encourage the developers and maintainers, but definitely not blame them. Especially, when a requested issue is not a bug,
but a new feature.

Thanks for the nice words!

I'm confident that we can deliver this in 5.0.0. I've a functional version with both issues reported by Mizuki in #13919#note-59 fixed, but it depends on
the newly #36162 that changes the notification reason from a static and generic text to a dynamic text.

#66 - 2021-11-08 23:15 - Marius BALTEANU

- Related to Feature #36162: Add notification reason to the email instead of the default static email footer added
#67 - 2021-11-09 11:10 - Dmitry Babenko
Marius BALTEANU wrote:

I'm confident that we can deliver this in 5.0.0.

Great! Thanks! It will be a huge leap for Redmine! :)

I've a functional version with both issues reported by Mizuki in #13919#note-59 fixed, but it depends on the newly #36162 that changes the
notification reason from a static and generic text to a dynamic text.

Actually, the default static email footer is just fine.
I think it is better to put #36162 for one of the future releases and not block the mentions feature if it is possible.
#68 - 2021-11-09 11:13 - Adrien Crivelli

| agree with Dmitry here, while #36162 would be nice, mentions would definitely be more useful and should not be blocked by improvements that can
be made later.

#69 - 2021-11-15 22:53 - Marius BALTEANU
- File 0001-Allow-users-to-be-mention.patch added

I'm attaching a patch that contains a fully working version without any known issue, it can be used for testing. In the meantime, I'm adding the
automated tests.

Please note that there is no difference between a mail received because you're the assignee and an email received because you have been
mentioned, we will add this as part of #36162.

Please let me know what do you think and if something is missing.

#70 - 2021-12-09 15:52 - Miodrag Milic

Can't wait for this one! Thx guys, you are awesome.

#71 - 2021-12-20 13:34 - jontofront jontofront

+

#72 - 2022-01-12 19:12 - Marius BALTEANU
- File deleted (0001-Allow-users-to-be-mention.patch)

#73 - 2022-01-12 19:22 - Marius BALTEANU

- File 0001-Allow-users-to-be-mentioned-using.patch added
I'm attaching an updated patch which includes some fixes and tests for the mentioning system.
| still need to change the user autocomplete in order to propose only users that are able to see the object in order to avoid those cases when you

mention a visible user, but he won't receive the notification because he cannot see that object (the same issue that we had on watchers). After | do
this, I'll commit the patch.

#74 - 2022-01-14 02:20 - Kohei Nakamura
+1
I've been really waiting for this feature.

This will be a great motivation for us to update Redmine 5.
Thanks for the development!

#75 - 2022-01-24 18:41 - Marius BALTEANU
- File 0001-Allow-users-to-be-mentioned-using-in-issues-and-wiki.patch added
I'm adding a new version of the patch that brings two important changes:
e only users that are able to see the object are proposed in users autocomplete.
e integrates with watchers permission (because this feature has a notification component) in order to allow mentioning only by users with
permission to add watchers on that object. For ex: only users with add_issue_watchers permission can mention users on issues.

I'm not sure if reusing the watcher permission is the best option or:

¢ we should add a specific permission mention_user for each type of object (issue, wiki pages, etc)
e adds a "global" permission

I would like some feedback before moving forward with the implementation.

#76 - 2022-01-24 23:27 - Adrien Crivelli

Using the existing permission sounds good to me. If future, real usage shows that it's not optimal we could always move to a dedicated permissions.
But until then | wouldn't overcomplicate things.

#77 - 2022-02-23 22:20 - Marius BALTEANU

- Subject changed from Mention user on comment/description using @user with autocomplete to Mention user on issues and wiki pages using @user
with autocomplete
- Status changed from New to Resolved

- Resolution set to Fixed

Feature added in r21435.

Now you can mention other users in issues and wiki pages:
e the user must have add watchers permission on that object in order to mention other users
e mentioned user will receive a notification email
¢ only visible users who can view the object can be mentioned

I'll leave this open for a while in order to get some feedback on the implementation.

#78 - 2022-02-24 22:33 - Marius BALTEANU

- Related to Feature #36699: Change the text of the user link when converting @user notation to html added

#79 - 2022-03-19 11:03 - Marius BALTEANU

- File highlight.png added

Feature completed!

Users mentions are now highlighted and rendered using a leading @:
highlight.png

#80 - 2022-03-19 11:03 - Marius BALTEANU

- Status changed from Resolved to Closed

#81 - 2022-05-11 22:11 - Marius BALTEANU
- Related to Defect #36909: Mentions not working if status is changed added

#82 - 2022-09-13 23:25 - Marius BALTEANU

- Related to Defect #37369: Mention auto-complete not works in bulk-edit comments added

#83 - 2022-10-21 14:33 - Marcin Szewczyk

| think that the :mention_users "Mention Users" permission was left behind (available in the Administration section) but doesn't do anything.

#84 - 2022-11-16 15:26 - Holger Just
- Related to Patch #37938: Unused permission "Mention user" added

#85 - 2023-05-15 14:07 - Go MAEDA

- Has duplicate Feature #38542: Better username completion in the editor added
#86 - 2023-08-23 03:00 - Frederico Oliveira
Marius BALTEANU wrote in #note-79:

Feature completed!

Users mentions are now highlighted and rendered using a leading @:

highlight.png

Hello Marius BALTEANU,
In order for the user mention to work, it is necessary to have the edit task permission. Is it not possible to leave only the permission to add observers?
#87 - 2023-11-23 09:08 - Cristian Spiescu
Hi there,

| see the discussion mentions the notion of "watcher". When mentioning an user, should that user also be added as watcher of the issue? Was the
"mention feature" designed in such a way?

| observe that this doesn't happen, although the users expect this. E.g. in GitHub the purpose of mentioning, is to add as watchers.

2025-07-03 11/12


https://www.redmine.org/projects/redmine/repository/svn/revisions/21435
https://www.redmine.org/users/107353

#88 - 2024-02-16 11:23 - Dennis Buehring

Im not sure if anyone here ever tried/used the plugins that implemented this feature a long time ago...

You were discussing permissions and stuff while missing the point of the mentions.
Mentions are a special case, i need to know that the person mentioned gets the info... missing email config aside, i dont want redmine to check the
users default email notification settings and then decide not to inform him ??

e Add an extra option to configure if i want to receive mentions-notifications

¢ Dont use default notification mail template, users tend to use rules to filter out notifications that do not directly address them.

¢ Dont list users that have no email or have notifications disabled in the User First Name User Last Name popup list

e add maybe an envelope icon next to users in that list, that will be notified by mail ( all this info is checked in mentionable.rb already, so why not
use it for something good ?)

Sorry if this sounds like a rant, but you guys took 11 years to reinvent the wheel and finally came up with some square rock with a wooden stick in the
middle...

#89 - 2024-10-04 13:46 - popy popy

Just a small addition.
To add the mentioned users as watchers on issue edit,
modify the the following code at the top of the function "self.deliver_issue_edit" in file app/models/mailer.rb :

def self.deliver_issue_edit (journal)
#add watchers of mentions in current change
journal.notified_mentions.each do |user|
issue = journal.journalized
issue.add_watcher (user)
end

To add the mentioned users as watchers on new issues,
modify the the following code at the top of the function "self.deliver_issue_add" in file app/models/mailer.rb :

def self.deliver_issue_add (issue)
#add watchers of mentions in current change
issue.notified_mentions.each do |user|
issue.add_watcher (user)
end

#90 - 2025-03-30 11:14 - Marius BALTEANU

- Related to Feature #39529: Add tooltips for clarifying non-notifiable user mentions added

#91 - 2025-03-30 11:14 - Marius BALTEANU

- Related to Feature #39528: Change mention link color for users without access to view issues added

Files

feature_13919_v1.patch 11.2 KB 2019-03-07 Mizuki ISHIKAWA
feature_13919_v2.patch 20.9 KB 2019-03-26 Mizuki ISHIKAWA
0001-Demo-for-acts_as_mentionable.patch 3.5 KB 2019-09-10 Marius BALTEANU
draft-feature-13919-v3.patch 16.2 KB 2020-02-13 Mizuki ISHIKAWA
draft-acts_as_mentionable.patch 16.9 KB 2020-02-13 Mizuki ISHIKAWA
email_template.png 144 KB 2020-04-05 Marius BALTEANU
0001-Demo-for-acts_as_mentionable.patch 26.5 KB 2020-04-05 Marius BALTEANU
0002-Prevent-multiple-emails-from-being-sent-to-a-user.patch 2.19 KB 2020-04-16 Mizuki ISHIKAWA
0003-Add-permission-check-before-sending-email.patch 4.38 KB 2020-04-16 Mizuki ISHIKAWA
0001-Allow-users-to-be-mentioned-using.patch 27.3 KB 2022-01-12 Marius BALTEANU
